%global gem_name activemodel


%global testdir %{_tmppath}/%{gem_name}-%{version}

Summary: A toolkit for building modeling frameworks
Name: rubygem-%{gem_name}
Version: 3.0.11
Release: 3%{?dist}
Group: Development/Languages
License: MIT
URL: http://www.rubyonrails.org
Source0: http://rubygems.org/gems/%{gem_name}-%{version}.gem
# git clone https://github.com/rails/rails.git && cd rails/activemodel && git checkout v3.0.11
# tar czvf activemodel-3.0.11-tests.tgz test/
Source1: %{gem_name}-%{version}-tests.tgz

# Fixes 'Disallowed type attribute: "yaml"' issue introduced by CVE-2013-0155
# and CVE-2013-0156 security fixes.
# https://github.com/rails/rails/commit/477f0e798106521865ec7f58026973163a580896
Patch0: rubygem-activemodel-3.0.20-Methods-that-return-nil-should-not-be-considered-YAM.patch

# CVE-2013-0276
# https://bugzilla.redhat.com/show_bug.cgi?id=909528
Patch1: rubygem-activemodel-3.2.12-CVE-2013-0276-attr_protected.patch

Requires: ruby(abi) = 1.9.1
Requires: ruby(rubygems)
Requires: rubygem(activesupport) = %{version}
Requires: rubygem(builder) => 2.1.2
Requires: rubygem(i18n) => 0.4.2
BuildRequires: rubygems-devel
BuildRequires: rubygem(activesupport) = %{version}
BuildRequires: rubygem(builder)
BuildRequires: rubygem(i18n) => 0.4.2
BuildRequires: rubygem(mocha)
BuildRequires: rubygem(minitest)
BuildArch: noarch
Provides: rubygem(%{gem_name}) = %{version}

%description
Rich support for attributes, callbacks, validations, observers,
serialization, internationalization, and testing. It provides a known
set of interfaces for usage in model classes. It also helps building
custom ORMs for use outside of the Rails framework.


%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires:%{name} = %{version}-%{release}

%description doc
Documentation for %{name}

%prep
%setup -q -c -T
mkdir -p .%{gem_dir}
gem install --local --install-dir .%{gem_dir} \
            --force %{SOURCE0}

pushd .%{gem_instdir}
%patch0 -p2
%patch1 -p2
popd

%build

%install
mkdir -p %{buildroot}%{gem_dir}
cp -pa .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

%check
rm -rf %{testdir}
mkdir %{testdir}
tar xzvf %{SOURCE1} -C %{testdir}
pushd %{testdir}

# load_path is not available, remove its require.
sed -i '1,2d' test/cases/helper.rb

ruby -I%{buildroot}%{gem_libdir} -Itest -e "Dir.glob('./test/**/*_test.rb').each {|t| require t}"

popd
rm -rf %{testdir}

%files
%defattr(-, root, root, -)
%dir %{gem_instdir}
%{gem_libdir}
%doc %{gem_instdir}/README.rdoc
%doc %{gem_instdir}/MIT-LICENSE
%{gem_cache}
%{gem_spec}

%files doc
%defattr(-, root, root, -)
%doc %{gem_instdir}/CHANGELOG
%doc %{gem_docdir}


%changelog
* Tue Feb 12 2013 Vít Ondruch <vondruch@redhat.com> - 3.0.11-3
- Fix for CVE-2013-0276.

* Thu Jan 10 2013 Vít Ondruch <vondruch@redhat.com> - 3.0.11-2
- Fixing issues introduced by CVE-2013-0155 and CVE-2013-0156.

* Tue Jan 24 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 3.0.11-1
- Rebuilt for Ruby 1.9.3.
- Update to ActiveModel 3.0.11.

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.10-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Aug 22 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.10-1
- Update to ActiveModel 3.0.10

* Mon Jul 04 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.9-1
- Update to ActiveModel 3.0.9

* Fri Mar 25 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.5-1
- Update to ActiveModel 3.0.5

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Thu Feb 03 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.3-3
- Removed unnecessary clean section.

* Mon Jan 31 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.3-2
- Added build dependencies.

* Tue Jan 25 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.3-1
- Upgraded to activemodel 3.0.3
- Added documentation subpackage
- Added test execution during build
- Removed unnecessary cleanup from install section

* Tue Oct 26 2010 Jozef Zigmund <jzigmund@dhcp-29-238.brq.redhat.com> - 3.0.1-1
- Initial package
